#!/usr/bin/env python

import sys
sys.path.append('scripts')
from config import *
import stats 
import random

config_list = []

def prepare_dpf(targets, particles, gmm, motion, motion_noise=None):
    s = TopCameraRandomUniform(TrackerDPF(1, particles, gmm))
    s.rng_config = {0:10, 1:1}
    #s.dummy_net = True
    p = PhysicalProcessFactory('WiseMovingTarget', targets)
    random.seed(0) # TODO: change this?
    for q in p.procs:
        q.motion = motion
        q.motion_noise = motion_noise
        q.update_time = 1
        q.rng_mapping = {0:0, 1:1}
        ### Field size is 100 x 60
        #q.x_init = random.uniform(0, 100)
        #q.y_init = random.uniform(0, 60)
        q.x_init = 30
        q.y_init = 30
    name = 'P' + str(particles) + '_Gmm' + str(gmm) + '_M' + str(motion)
    folder = 'WiseCamSim_' + name
    c = Configuration(s, name, folder, p) 
    config_list.append(c)


#prepare_dpf(1, 100, -1, 'lin_random', 0.3)
#prepare_dpf(1, 300, -1, 'lin_random', 0.3)
#prepare_dpf(1, 500, -1, 'lin_random', 1)

#prepare_dpf(1, 100, 1, 'lin_random', 0.3)
#prepare_dpf(1, 300, 1, 'lin_random', 0.3)
#prepare_dpf(1, 500, 1, 'lin_random', 1)

#prepare_dpf(1, 100, 5, 'lin_random', 0.3)
#prepare_dpf(1, 300, 5, 'lin_random', 0.3)
#prepare_dpf(1, 500, 5, 'lin_random', 0.3)

prepare_dpf(1, 700, -1, 'lin_random', 1)
#prepare_dpf(1, 600, 1, 'lin_random', 0.3)
prepare_dpf(1, 700, 5, 'lin_random', 1)

#numbers_of_nodes = range(2, 11, 2)
#numbers_of_nodes = range(100, 1000, 100) + range(1000, 2001, 200)
#numbers_of_nodes = range(50, 500, 50) + range(500, 1001, 100)
#numbers_of_nodes = [100, 150, 200, 250, 300]
#numbers_of_nodes = [100, 500]
#numbers_of_nodes = [50, 100, 150, 200, 250, 300]
#numbers_of_nodes = [10, 50, 100, 300, 500, 700, 1000]
#numbers_of_nodes = [500]
numbers_of_nodes = [10, 50, 100]
#sim_time_limit = 3600
#sim_time_limit = 1200
sim_time_limit = 600
run_simulation = True
#run_simulation = False

m = MultipleRun(numbers_of_nodes, config_list, sim_time_limit, run_simulation, True)
m.run_all()
#m.calculate_stats_tid(0)
#m.plot_mse_tid(0, plot_maxmin=False)
#m.plot_delay_tid(0, plot_maxmin=False)
#m.plot_processedsamples_tid(0)
#m.plot_mse_tid(0, plot_maxmin=True, out_eps='plot_mse_maxmin.eps')
#m.plot_delay_tid(0, plot_maxmin=True, out_eps='plot_delay_maxmin.eps')

r = m.get_results()
mse = stats.mse(r)
delay = stats.delay(r)
samples = stats.samples(r)

mse.plot_tid(0)
delay.plot_tid(0)
samples.plot_tid(0)
mse.plot_tid(0, out_eps='plot_mse_maxmin.eps', plot_maxmin=True)
delay.plot_tid(0, out_eps='plot_delay_maxmin.eps', plot_maxmin=True)

mse2 = stats.mse2(r)
mse2.plot_tid(0)
mse3 = stats.mse3(r)
mse3.plot_tid(0)

#from scipy import *
#from numpy import *
#from pylab import *
#
#figure(1, figsize=(10, 5))
#clf()
#
#tid = 0
#for res in m.results:
#    ls = sorted(res.items(), key=lambda x: x[0])
#    for n, r in ls:
#        valids = filter(lambda i: not i.t_lost, r.stats[tid])
#        valids = map(lambda i: i.error, valids)
#        break # just take the first one!
#data = valids
#
##print 'TEST ', data
#
##(n, bins, patches) = hist(data, bins=1000, range=(-10, 10))
##(n, bins, patches) = hist(data, bins=1000, range=(0, 1))
##(n, bins, patches) = hist(data)
#show()
