#!/usr/bin/env python

def read_file_to_tables(fname, select_field, parse_select=None, 
                        skip_first_line=True, parsers=[]):
    lines = None
    with open(fname, 'r') as f:
        lines = f.readlines();
    if skip_first_line:
        del lines[0] # remove first line
    tables = {}
    for l in lines:
        ls = l.split();
        fields = []
        if parse_select:
            sel = parse_select(ls[select_field])
        else:
            sel = ls[select_field]
        del ls[select_field]
        for (s, p) in map(None, ls, parsers):
            if not s:
                break # More parsers than fields
            if p:
                fields.append(p(s))
            else:
                fields.append(s)
        if sel not in tables:
            tables[sel] = []
        tables[sel].append(fields)
    return tables
